
*** printer device dependent code tag for DotsPerfect-MX80 ***

	SECTION		printer

*---- Included files ----------------------------------------------

	INCLUDE		"driver.i"	;Condensed include file

*---- Imported Names ----------------------------------------------

	XREF		_Init
	XREF		_Expunge
	XREF		_Open
	XREF		_Close

	XREF		_CommandTable
	XREF		_PrinterSegmentTable
	XREF		_DoSpecial
	XREF		_Render

*---- Exported Names ----------------------------------------------

	XDEF		_PEDData

*******************************************************************

		MOVEQ	#0,D0		; show error for OpenLibrary()
		RTS

		DC.W	1		; Version
		DC.W	0		; Revision

_PEDData:
		DC.L	printerName
		DC.L	_Init
		DC.L	_Expunge
		DC.L	_Open
		DC.L	_Close
		DC.B	PPC_BWGFX	; Printer Class B&W graphics
		DC.B	PCC_BW		; Color Class black & white
		DC.B	80		; Max Columns
		DC.B	1		; Number of Character Sets
		DC.W	8		; Number of rows
		DC.L	960		; Maximum of X dots
		DC.L	0		; Maximum of Y dots
		DC.W	120		; X Dots per inch
		DC.W	72		; Y Dots per inch
		DC.L	_CommandTable	; as defined in data.c
		DC.L	_DoSpecial	; as defined in dospecial.c
		DC.L	_Render		; as defined in render.c
		DC.L	30		; Timeout
		DC.L	0		; 8 bit chars
printerName:
		STRING	<'DotsPerfect-MX80'>

		END


