/*****************************************************
 *                  Menu Definitions                 *
 *                                                   *
 *             Created with Menu Creator             *
 *                        by                         *
 *                   David Pehrson                   *
 *                                                   *
 *         Copyright (C) 1986  David Pehrson         *
 *                 Mantis Development                *
 *                                                   *
 *****************************************************/

#include <exec/types.h>
#include <intuition/intuition.h>

char stTopaz[] = "topaz.font";

struct TextAttr taPlain =
{
	(STRPTR) stTopaz, 8, FS_NORMAL, FPF_ROMFONT
};

struct TextAttr taBIU =
{
	(STRPTR) stTopaz, 8, FSF_BOLD | FSF_ITALIC | FSF_UNDERLINED, FPF_ROMFONT
};

struct TextAttr taBU =
{
	(STRPTR) stTopaz, 8, FSF_BOLD | FSF_UNDERLINED, FPF_ROMFONT
};

struct TextAttr taBI =
{
	(STRPTR) stTopaz, 8, FSF_BOLD | FSF_ITALIC, FPF_ROMFONT
};

struct TextAttr taB =
{
	(STRPTR) stTopaz, 8, FSF_BOLD, FPF_ROMFONT
};

struct TextAttr taIU =
{
	(STRPTR) stTopaz, 8, FSF_ITALIC | FSF_UNDERLINED, FPF_ROMFONT
};

struct TextAttr taI =
{
	(STRPTR) stTopaz, 8, FSF_ITALIC, FPF_ROMFONT
};

struct TextAttr taU =
{
	(STRPTR) stTopaz, 8, FSF_UNDERLINED, FPF_ROMFONT
};

struct IntuiText ItemText[] =
{
	{ 0, 1, JAM1, 0, 1, &taPlain, "Backup", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "Restore", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "About", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "Quit", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "   Compression", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "   No Compression", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "   Listing", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "   No Listing", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "   Speech", NULL },
	{ 0, 1, JAM1, 0, 1, &taPlain, "   No Speech", NULL },
};

struct MenuItem Items[] =
{
	{	/* Backup */
		&Items[1], 0, 0, 72, 10, 
			ITEMENABLED | ITEMTEXT | HIGHCOMP ,
			0, (APTR)&ItemText[0], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[2], 0, 10, 72, 10, 
			ITEMENABLED | ITEMTEXT | HIGHCOMP ,
			0, (APTR)&ItemText[1], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[3], 0, 20, 72, 10, 
			ITEMENABLED | ITEMTEXT | HIGHCOMP,
			0, (APTR)&ItemText[2], NULL, NULL, NULL, MENUNULL 
	},
	{
		NULL, 0, 30, 72, 10, 
			ITEMENABLED | ITEMTEXT | HIGHCOMP,
			0, (APTR)&ItemText[3], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[5], 0, 0, 152, 10, 		/* Compression */
			ITEMENABLED | ITEMTEXT | CHECKIT | HIGHCOMP | CHECKED,
			2, (APTR)&ItemText[4], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[6], 0, 10, 152, 10, 		/* No Compression */
			ITEMENABLED | ITEMTEXT | CHECKIT | HIGHCOMP,
			1, (APTR)&ItemText[5], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[7], 0, 20, 152, 10, 		/* Listing */
			ITEMENABLED | ITEMTEXT | CHECKIT | HIGHCOMP | CHECKED,
			8, (APTR)&ItemText[6], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[8], 0, 30, 152, 10, 		/* No Listing */
			ITEMENABLED | ITEMTEXT | CHECKIT | HIGHCOMP,
			4, (APTR)&ItemText[7], NULL, NULL, NULL, MENUNULL 
	},
	{
		&Items[9], 0, 40, 152, 10, 		/* Speech */
			ITEMENABLED | ITEMTEXT | CHECKIT | HIGHCOMP | CHECKED,
			32, (APTR)&ItemText[8], NULL, NULL, NULL, MENUNULL 
	},
	{
		NULL, 0, 50, 152, 10, 			/* No Speech */
			ITEMENABLED | ITEMTEXT | CHECKIT | HIGHCOMP,
			16, (APTR)&ItemText[9], NULL, NULL, NULL, MENUNULL 
	},
};

struct Menu Titles[] =
{
	{ &Titles[1], 3, 0, 70, 0, MENUENABLED, "Project", &Items[0],0,0,0,0 },
	{ NULL, 72, 0, 54, 0, MENUENABLED, "Flags", &Items[4],0,0,0,0 },
};

