/*
 * optwind.h : data for the option input window.
 *             created with PowerWindows, but much modified.
 */

#define XOPT 6L		/* constants for moving the whole mess around */
#define YOPT 15L


extern struct TextAttr TOPAZ60;
extern struct TextAttr TOPAZ80;

UBYTE UNDOBUFFER1[5];
UBYTE UNDOBUFFER2[5];

SHORT BorderVectors1[] = {
    0,0,
    26,0,
    26,19,
    0,19,
    0,1
};
struct Border Border1 = {
    -2,-2,    /* XY origin relative to container TopLeft */
    3,0,COMPLEMENT,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors1,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct IntuiText IText1 = {
    2,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    2,4,    /* XY origin relative to container TopLeft */
    &TOPAZ60,    /* font pointer or NULL for default */
    (UBYTE *)"OK",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct Gadget Gadget7 = {
    NULL,    /* next gadget */
    XOPT+67,YOPT+138,    /* origin XY of hit box relative to window TopLeft */
    22,16,    /* hit box width and height */
    NULL,    /* gadget flags */
    RELVERIFY,    /* activation flags */
    BOOLGADGET,    /* gadget type flags */
    (APTR)&Border1,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    &IText1,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    NULL,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

SHORT BorderVectors2[] = {
    0,0,
    52,0,
    52,11,
    0,11,
    0,0
};
struct Border Border2 = {
    -2,-1,    /* XY origin relative to container TopLeft */
    3,0,JAM1,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors2,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct IntuiText IText2 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    14,1,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"ALL",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct Gadget Gadget6 = {
    &Gadget7,    /* next gadget */
    XOPT+84,YOPT+118,    /* origin XY of hit box relative to window TopLeft */
    49,10,    /* hit box width and height */
    SELECTED,    /* gadget flags */
    TOGGLESELECT,    /* activation flags */
    BOOLGADGET,    /* gadget type flags */
    (APTR)&Border2,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    &IText2,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    NULL,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

SHORT BorderVectors3[] = {
    0,0,
    52,0,
    52,11,
    0,11,
    0,0
};
struct Border Border3 = {
    -2,-1,    /* XY origin relative to container TopLeft */
    3,0,JAM1,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors3,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct IntuiText IText3 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    6,1,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"$/gal",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct Gadget Gadget5 = {
    &Gadget6,    /* next gadget */
    XOPT+18,YOPT+118,    /* origin XY of hit box relative to window TopLeft */
    49,10,    /* hit box width and height */
    NULL,    /* gadget flags */
    TOGGLESELECT,    /* activation flags */
    BOOLGADGET,    /* gadget type flags */
    (APTR)&Border3,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    &IText3,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    NULL,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

SHORT BorderVectors4[] = {
    0,0,
    52,0,
    52,11,
    0,11,
    0,0
};
struct Border Border4 = {
    -2,-1,    /* XY origin relative to container TopLeft */
    3,0,JAM1,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors4,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct IntuiText IText4 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    2,1,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"mi/gal",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct Gadget Gadget4 = {
    &Gadget5,    /* next gadget */
    XOPT+84,YOPT+99,    /* origin XY of hit box relative to window TopLeft */
    49,10,    /* hit box width and height */
    NULL,    /* gadget flags */
    TOGGLESELECT,    /* activation flags */
    BOOLGADGET,    /* gadget type flags */
    (APTR)&Border4,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    &IText4,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    NULL,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

SHORT BorderVectors5[] = {
    0,0,
    52,0,
    52,11,
    0,11,
    0,0
};
struct Border Border5 = {
    -2,-1,    /* XY origin relative to container TopLeft */
    3,0,JAM1,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors5,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct IntuiText IText5 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    9,1,    /* XY origin relative to container TopLeft */
    &TOPAZ80,    /* font pointer or NULL for default */
    (UBYTE *)"$/mi",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct Gadget Gadget3 = {
    &Gadget4,    /* next gadget */
    XOPT+18,YOPT+99,    /* origin XY of hit box relative to window TopLeft */
    49,10,    /* hit box width and height */
    NULL,    /* gadget flags */
    TOGGLESELECT,    /* activation flags */
    BOOLGADGET,    /* gadget type flags */
    (APTR)&Border5,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    &IText5,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    NULL,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

UBYTE Gadget2SIBuff[5] =
    "";
struct StringInfo Gadget2SInfo = {
    Gadget2SIBuff,    /* buffer where text will be edited */
    UNDOBUFFER1,    /* optional undo buffer */
    0,    /* character position in buffer */
    5,    /* maximum number of characters to allow */
    0,    /* first displayed character buffer position */
    0,0,0,0,0,    /* Intuition initialized and maintained variables */
    0,    /* Rastport of gadget */
    0,    /* initial value for integer gadgets */
    NULL    /* alternate keymap (fill in if you set the flag) */
};

SHORT BorderVectors6[] = {
    0,0,
    55,0,
    55,16,
    0,16,
    0,1
};
struct Border Border6 = {
    -3,-4,    /* XY origin relative to container TopLeft */
    3,0,COMPLEMENT,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors6,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct Gadget Gadget2 = {
    &Gadget3,    /* next gadget */
    XOPT+84,YOPT+60,    /* origin XY of hit box relative to window TopLeft */
    48,21,    /* hit box width and height */
    NULL,    /* gadget flags */
    RELVERIFY+STRINGCENTER,    /* activation flags */
    STRGADGET,    /* gadget type flags */
    (APTR)&Border6,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    NULL,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    (APTR)&Gadget2SInfo,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

UBYTE Gadget1SIBuff[5] =
    "";
struct StringInfo Gadget1SInfo = {
    Gadget1SIBuff,    /* buffer where text will be edited */
    UNDOBUFFER2,    /* optional undo buffer */
    0,    /* character position in buffer */
    5,    /* maximum number of characters to allow */
    0,    /* first displayed character buffer position */
    0,0,0,0,0,    /* Intuition initialized and maintained variables */
    0,    /* Rastport of gadget */
    0,    /* initial value for integer gadgets */
    NULL    /* alternate keymap (fill in if you set the flag) */
};

SHORT BorderVectors7[] = {
    0,0,
    56,0,
    56,16,
    0,16,
    0,1
};
struct Border Border7 = {
    -4,-4,    /* XY origin relative to container TopLeft */
    3,0,COMPLEMENT,    /* front pen, back pen and drawmode */
    5,    /* number of XY vectors */
    BorderVectors7,    /* pointer to XY vectors */
    NULL    /* next border in list */
};

struct Gadget Gadget1 = {
    &Gadget2,    /* next gadget */
    XOPT+16,YOPT+60,    /* origin XY of hit box relative to window TopLeft */
    50,14,    /* hit box width and height */
    NULL,    /* gadget flags */
    RELVERIFY+STRINGCENTER,    /* activation flags */
    STRGADGET,    /* gadget type flags */
    (APTR)&Border7,    /* gadget border or image to be rendered */
    NULL,    /* alternate imagery for selection */
    NULL,    /* first IntuiText structure */
    NULL,    /* gadget mutual-exclude long word */
    (APTR)&Gadget1SInfo,    /* SpecialInfo structure */
    NULL,    /* user-definable data */
    NULL    /* pointer to user-definable data */
};

#define GadgetList1 Gadget1

struct IntuiText IText10 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+22,YOPT+80,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"Type of Graph",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct IntuiText IText9 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+93,YOPT+46,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"End",    /* pointer to text */
    &IText10    /* next IntuiText structure */
};

struct IntuiText IText8 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+16,YOPT+45,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"Start",    /* pointer to text */
    &IText9    /* next IntuiText structure */
};

struct IntuiText IText7 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+21,YOPT+35,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"Select Years",    /* pointer to text */
    &IText8    /* next IntuiText structure */
};

struct IntuiText IText6 = {
    3,0,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+8,YOPT+17,    /* XY origin relative to container TopLeft */
    &TOPAZ60,    /* font pointer or NULL for default */
    (UBYTE *)"SELECT OPTIONS",    /* pointer to text */
    &IText7    /* next IntuiText structure */
};

#define IntuiTextList1 IText6



/*
 * Text for error messages in option window 
 */
struct IntuiText ErrText1 = {
    2,1,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+10,YOPT+5,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"Invalid Start Year",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct IntuiText ErrText2 = {
    2,1,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+10,YOPT+5,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"Invalid End Year",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

struct IntuiText ErrText3 = {
    2,1,JAM2,    /* front and back text pens, drawmode and fill byte */
    XOPT+4,YOPT+5,    /* XY origin relative to container TopLeft */
    NULL,    /* font pointer or NULL for default */
    (UBYTE *)"End less than Start",    /* pointer to text */
    NULL    /* next IntuiText structure */
};

/* end of PowerWindows source generation */
