/* The memory allocation routines used */
/* The standard C routines malloc, free should work as well */
/* (I was trying to reduce overhead, time & space) */
#define ALLOC(type) ((type *)AllocMem(sizeof(type), NULL))
#define FREE(type, ptr) FreeMem((char *)(ptr), sizeof(type));
#define ALLOCMEM(size) ((char *)AllocMem((size), NULL))
#define FREEMEM(size, ptr) FreeMem((ptr), (size));

#define ALLOC_VALUE(into) (into = ALLOC(struct _value))
#define FREE_VALUE(ptr) FREE(struct _value, ptr)

