/* Command Table Data for DotsPerfect-MX80 */

char *CommandTable[] = {
    "\xfd\x1b@\xfd",	/* reset			RIS	*/
    "\xff",		/* initialize			RIN	*/
    "\x0a",		/* lf				IND	*/
    "\x0d\x0a", 	/* return, lf			NEL	*/
    "\xff",	 	/* reverse lf			RI	*/

    "\x1b5\x1b-\xfe\x1bF",/* normal character set	SGR0	*/
    "\x1b4",		/* italics on			SGR3	*/
    "\x1b5",		/* italics off			SGR23	*/
    "\x1b-\x01",		/* underline on			SGR4	*/
    "\x1b-\xfe",		/* underline off		SGR24	*/
    "\x1bE",		/* boldface on			SGR1	*/
    "\x1bF",		/* boldface off			SGR22	*/

    "\xff",		/* set foreground color		SFC	*/
    "\xff",		/* set background color		SBC	*/

    "\x12\x1bW\xfe",	/* normal pitch			SHORP0	*/
    "\xff",		/* elite on			SHORP2	*/
    "\xff",		/* elite off			SHORP1	*/
    "\x0f",		/* condensed (fine) on		SHORP4	*/
    "\xff",		/* condensed off		SHORP3	*/
    "\x1bW\x01",	/* enlarged on			SHORP6	*/
    "\x1bW\xfe",	/* enlarged off			SHORP5	*/

    "\x1bE",		/* shadow print on (emphasized)	DEN6	*/
    "\x1bF",		/* shadow print off(emphasized)	DEN5	*/
    "\x1bG",		/* doublestrike on		DEN4	*/
    "\x1bH",		/* doublestrike off		DEN3	*/
    "\x1bx1",		/* Near Letter Quality on	DEN2	*/
    "\x1bx0",		/* Near Letter Quality off	DEN1	*/

    "\x1bS\xfe",	/* superscript on		SUS2	*/
    "\x1bT",		/* superscript off		SUS1	*/
    "\x1bS\x01",	/* subscript on			SUS4	*/
    "\x1bT",		/* subscript off		SUS3	*/
    "\x1bT",		/* normalize			SUS0	*/

    "\xff",		/* partial line up		PLU	*/
    "\xff",		/* partial line down		PLD	*/

    "\xff",		/* US char set			FNT0	*/
    "\xff",		/* French char set		FNT1	*/
    "\xff",		/* German char set		FNT2	*/
    "\xff",		/* UK char set			FNT3	*/
    "\xff",		/* Danish I char set		FNT4	*/
    "\xff",		/* Swedish char set		FNT5	*/
    "\xff",		/* Italian char set		FNT6	*/
    "\xff",		/* Spanish char set		FNT7	*/
    "\xff",		/* Japanese char set		FNT8	*/
    "\xff",		/* Norweign char set		FNT9	*/
    "\xff",		/* Danish II char set		FNT10	*/

    "\xff",		/* proportional on		PROP2	*/
    "\xff",		/* proportional off		PROP1	*/
    "\xff",		/* proportional clear		PROP0	*/
    "\xff",		/* set prop offset		TSS	*/

    "\xff",		/* auto left justify		JFY5	*/
    "\xff",		/* auto right justify		JFY7	*/
    "\xff",		/* auto full justify		JFY6	*/
    "\xff",		/* auto justify off		JFY0	*/
    "\xff",		/* letter space			JFY3	*/
    "\xff",		/* auto center on		JFY1	*/

    "\x1b0",		/* 1/8" line spacing		VERP0	*/
    "\x1b2",		/* 1/6" line spacing		VERP1	*/

    "\x1bC",		/* set form length		SLPP	*/
    "\x1bN",		/* Perf skip on			PERF	*/
    "\x1bO",		/* Perf skip off		PERF0	*/
    "\xff",		/* left margin set		LMS	*/
    "\x1bQ",		/* right margin set		RMS	*/
    "\xff",		/* top margin set		TMS	*/
    "\xff",		/* bottom margin set		BMS	*/
    "\xff",		/* top & bottom margin set	STBM	*/
    "\xff",		/* left & right margin set	SLRM	*/
    "\xff",	 	/* clear margins		CAM	*/

    "\xff",		/* set horizontal tab		HTS	*/
    "\xff",		/* set vertical tab		VTS	*/
    "\xff",		/* clear horizontal tab		TBC0	*/
    "\x1bD\xfe",	/* clear all horizontal tabs	TBC3	*/
    "\xff",		/* clear vertical tab		TBC1	*/
    "\xff",		/* clear all vertical tabs	TBC4	*/
    "\x1bD\xfe",	/* clear all h & v tabs		TBCALL	*/
    "\x1bD\010\020\030\040\050\060\070\100\110\120\xfe",
     			/* set default tabs		TBSALL	*/

    "\xff"		/* extended command		EXTEND	*/
};
