/*	genv.c
 
 
 
	copyright (C) 1987 Stuart Lynne
 
	Copying and use of this program are controlled by the terms of the
	Free Software Foundations GNU Emacs General Public License.
 
 
	version		0.1		March 31/1987
 
	
 
environment variables
 
	The following evironment variables are defined:
 
	MAILBOX		current user's mailbox, 	"sl"
	NAME		current user's name, 		"Stuart Lynne"
	DOMAIN		domain of this machine, 	"mac.van-bc.can"
	MAILDIR		where mail is kept,		"/usr/mail"
	CONFDIR		where config data is  kept,	"/usr/lib/uucp"
	SPOOLDIR	where spooled files are 	"/usr/spool/uucp"
	LOGDIR		where log file are placed	"/usr/spool/uucp"
	PUBDIR		public spool directory		"/usr/spool/uucppublic"
	NEWSDIR		news directory			"/usr/spool/news"
	TEMPDIR		where temp files are created	"/tmp"
	HOME		where uses private files are	"/usr/sl"
	MAILSERVICE	who do we send remote mail	"van-bc"
	NODENAME	what is our local nodename	"slmac"
	DEVICE		what is the default device	".a"
	SPEED		what is the default speed	"1200"
 
*/
 

#define	MAILBOX		"MAILBOX"
#define	NAME		"NAME"
#define	DOMAIN		"DOMAIN"
#define	MAILDIR		"MAILDIR"
#define HOME		"HOME"

#define	CONFDIR		"CONFDIR"
#define SPOOLDIR	"SPOOLDIR"
#define LOGDIR		"LOGDIR"
#define	PUBDIR		"PUBDIR"
#define NEWSDIR2	"NEWSDIR"
#define TEMPDIR		"TEMPDIR"
#define	MAILSERVICE	"MAILSERVICE"

#define NODENAME	"NODENAME"
#define	DEVICE		"DEVICE"
#define	SPEED		"SPEED"
 
extern char	*mailbox;
extern char	*name;
extern char	*domain;
extern char	*maildir;
extern char	*home;

extern char	*confdir;
extern char	*spooldir;
extern char	*logdir;
extern char	*pubdir;
extern char	*tempdir;
extern char	*mailserv;

extern char	*nodename;
extern char	*device;
extern char	*speed;
extern char	*newsdir;

void loadenv();
void mkfilename();


