/*
 *                     +-----------------------------+
 *                     | Mandelbrot Construction Set |
 *                     +-----------------------------+
 * 
 *                   (C) By Olaf {* KosmoSoft *} Seibert
 *                         15 September 1987 V1.0
 * 
 * In article <4383@videovax.Tek.COM>, Steven E. Rice, P.E.
 *    (stever@videovax.Tek.COM) writes:
 * > All rights reserved. This material may be redistributed only where
 * > such redistribution is without charge and without restrictions on
 * > further redistribution. Incorporation of this material in a 
 * > compilation or other collective work constitutes permission from
 * > the intermediary to all recipients to freely redistribute the entire
 * > collection.
 * > All other uses are prohibited.
 *
 * Copyright 1987 by Olaf Seibert, KosmoSoft Productions.
 *
 * Disclaimer: The author of this program is not responsible for any 
 * direct, indirect, incidental or consequential damages caused by
 * using or not using this material, or any documentation that may or
 * may not be supplied.
 *
 * Notice: The palette and the file requester were written by others.
 * (=RJ= Mical and C. Heath respectively)
 * These packages were adapted to be more generally usable, and to 
 * conform more to my own taste.
 * I had to remove a number of bugs from Jim Kents IFF routines.
 *
 * Mind you: _I_ didn't mention ShareWare!
 *
 */

/************************************************************************
* .-------------------------------------------------------------------. *
* |               --- >>>  AUTHOR INFORMATION  <<< ---                | *
* `-------------------------------------------------------------------' *
*=======================================================================*
*                                 ||                                    *
*  Study Address                  ||   Home address                     *
*  (may vary greatly)             ||   (safe way to send fanmail)       *
*                                 ||                                    *
*  Olaf Seibert                   ||   Olaf Seibert                     *
*  Vossendijk 149                 ||   Beek 5                           *
*  6534 TN  Nijmegen              ||   5815 CS  Merselo                 *
*  The Netherlands                ||   The Netherlands                  *
*                                 ||                                    *
*  International (...-31)80561045 ||   International (...-31)4786205    *
*  or National 080-561045         ||   or National 04786-205            *
*                                 ||                                    *
*=======================================================================*
************************************************************************/
