/* Console I/O Routines Header File
 * Filename: ConsoleStuff.h
 *
 * This header file defines information used by routines supplied in
 * Rob Peck's "Programmer's Guide to the Amiga", 1987.
 */

#include <exec/io.h>

typedef struct ConIOBlocks {
	struct IOStdReq *writeReq;			/* I/O write request */
	struct IOStdReq *readReq;			/* I/O read request */
	struct MsgPort *tpr;				/* pointer to ReplyPort */
										/* for the console read */
	} ConIOBlocks;

void ConWrite();
ConIOBlocks *CreateConsole();
int DeleteConsole();
void EnqueueRead();
int CGetCharacter();
