/*


            soundproc.h    M.E.S.   87-12-88


*/
#include <exec/types.h>
#include "exec/execbase.h"
  #include     "exec/nodes.h"
    #include     "exec/lists.h"
    #include     "exec/ports.h"
    #include     "exec/tasks.h"
    #include     "exec/io.h"
/*
#include "proto/exec.h"
#include "proto/dos.h"
#pragma syscall AddPort 162 901
#pragma syscall RemPort 168 901
#pragma syscall PutMsg 16e 9802
#pragma syscall GetMsg 174 801
#pragma syscall ReplyMsg 17a 901
#pragma syscall WaitPort 180 801
#pragma syscall FindPort 186 901
#pragma syscall Wait 13e 1
*/

#define OFF          2
#define ON           1
#define INTERRUPTED  0
#define TURNOFF      1
#define VERBAGE      2
#define IGOTMESSAGE  3
#define YAHSOUND       1
#define HAPPYSOUND     2
#define BOMBSOUND      3
#define DICEROLL       4
#define WAVES_TOTAL  1024L  /* alloc size for instrument's waves */

extern struct MsgPort *CreatePort();
extern int InitIOA();
extern void makewaves();
extern void Happy();
extern void Bomb();
extern void Click();
extern void YahtzeeSound();
extern void StopVoices();
extern void FinishProg();
extern BYTE *wptr;

struct data
   {
      char *string;
      ULONG function;
      int length;
      ULONG flags;
      UBYTE id;
   };

struct test_message
   {
      struct Message m;
      struct data    d;
   };
static struct test_message *t;

/*  struct ExecBase *SysBase = 0; */
 struct DosLibrary  *DOSBase;
/*   int   printf(char *,);       */
